# 
#       #=======================================================#     _\|/_
#      #  __  _____           ___                    ___       #       /|\
#     #  /      |      ^     |   \  |         ^     |   \     #           _\|/_
#    #   \__    |     / \    |___/  |        / \    |___/    #             /|\
#   #       \   |    /___\   |  \   |       /___\   |   \   #  _\|/_
#  #     ___/   |   /     \  |   \  |____  /     \  |___/  #    /|\     
# #                                                       #             _\|/_
##=======================================================#               /|\
#
#
##  Makefile.driver.inc: contains boilerplate rules for
##                       higher-level Starlab makefiles.
##.............................................................................
##    version 1.1:	Dec 1993	Piet Hut & Steve McMillan
##.............................................................................
#
#   All macros not explicitly defined below are assumed to be declared
#   in the local makefile being used.
#..............................................................................

SHELL = /bin/sh

RM = /bin/rm
LS = /bin/ls
CP = /bin/cp

BIN = $(STARLAB_PATH)/bin
INC = $(STARLAB_PATH)/inc
LIB = $(STARLAB_PATH)/lib

INC_STAR = $(STARLAB_PATH)/inc/star

MAKEWALK = $(STARLAB_PATH)/sbin/makewalk

#..............................................................................

# if make is invoked without argument, the following help message is displayed:

help:
	@echo This Makefile offers the following make options:
	@echo '  all: executes a   make lib   and   make bin'
	@echo '  lib: executes a   make lib   everywhere in'
	@echo '          $(DIRS)'
	@echo '  bin: executes a   make bin   everywhere in'
	@echo '          $(DIRS)'
	@echo '  clean: removes core file and emacs backup versions, and'
	@echo '         executes a   make clean   everywhere in'
	@echo '           $(DIRS)'

#..............................................................................

sure:	clean all

#..............................................................................

all:	lib bin

#..............................................................................

lib:
	$(MAKEWALK) lib $(DIRS)

#..............................................................................

bin:
	@$(MAKEWALK) bin $(DIRS)

#..............................................................................

tarlist:
	@make_list_files `$(LS) [A-Z]* | grep -v "~"`
	@$(MAKEWALK).quiet tarlist $(DIRS)

#..............................................................................

clean:
	@-$(RM) -f core *~ ...*.C
	@$(MAKEWALK) clean $(DIRS)

cleanbin:
	@$(MAKEWALK) cleanbin $(DIRS)

cleanalt:
	@$(MAKEWALK) cleanalt $(DIRS) alt

#..............................................................................

##=======================================================================//
##  +---------------+        _\|/_        +------------------------------\\
##  |  the end of:  |         /|\         |  Makefile.driver.inc
##  +---------------+                     +------------------------------//
##========================= STARLAB =====================================\\ 

